[[!--
  About VOCABULARY and AUTHORITY representation:

  This application page is used to create and edit skos:ConceptScheme or crm:E32_Authority_Document, corresponding to thesauri or authority lists.
  Creating a skos:ConceptScheme is suitable for hierarchical conceptual structure where the hierarchy is best described by broader or narrower type of relations.
  Creating a crm:E32_Authority_Document can represent lists of persons, periods, events, etc. The assumption is that all entities in an Authority Document have the same
  type and relations between entities are based on cidoc-crm entities and their corresponding properties; 

--]]
[[#>  rsp:HierarchyManagerTemplate title="Authority Manager" addTitle='Authority']]
    [[#*inline "addNewStructureForm"]]
<semantic-search id="scheme-iri-selector">
<semantic-search-form-query fields='[{"id": "label", "label": "scheme label", "xsdDatatype": "http://www.w3.org/2001/XMLSchema#string"},
        {
  "id": "entitytype",
  "label": "Entity Type",
  "xsdDatatype": "xsd:anyURI",
  "valueSetPattern": "SELECT $value $label WHERE { 
      ?value crm:P71i_is_listed_in <http://www.researchspace.org/resource/system/vocab/authority_manager_config_types>  .
      ?value <http://www.researchspace.org/resource/system/authority_manager/item_label>  ?label .
    }"
  }
]' query-template='{
"queryString": "SELECT $schemeLabel ?entityTypeURI { BIND($label as ?schemeLabel). BIND(?entitytype as ?entityTypeURI )}",
"arguments": {
  "label": {"type": "xsd:string"},
  "entitytype":{"type":"xsd:anyURI"}
}
}'>
  <semantic-form-text-input for="label" placeholder="[[i18n 'enter_new' bundle='languages/resource_vocabularymanager' locale=this.lang]]">
  </semantic-form-text-input>
    <semantic-form-checklist-input class="class name" class-item-name="item class name" for="entitytype" type="checkbox">
    </semantic-form-checklist-input>
    <button classname="btn btn-primary" name="submit" style="margin-top: 0;" type="button">
    [[i18n "create_authority" bundle="languages/resource_vocabularymanager" locale=this.lang]]
    </button>
  </semantic-search-form-query>
  <semantic-search-result-holder>
<semantic-search-result>
<semantic-query id="new-scheme-form" query='
                                      SELECT ?schemeLabel ?scheme ?entityType ?exists WHERE {
                                        BIND(IRI(CONCAT(STR(Default:), "vocab/", ENCODE_FOR_URI(REPLACE(LCASE(?schemeLabel), "\\s", "_")))) AS ?scheme) .
                                        BIND(?entityTypeURI as ?entityType)
                                        OPTIONAL {
                                          ?scheme a skos:ConceptScheme .
                                          BIND(true as ?exists) .
                                        }
                                        OPTIONAL {
                                          ?scheme a crm:E32_Authority_Document .
                                          BIND(true as ?exists) .
                                        }
                                      }
                                    ' template="{{>  template}}">
<template id="template">
<div class="confirm-message">
      {{#if bindings.0.exists}}
      <div>
       [[i18n "authority_with" bundle="languages/resource_vocabularymanager" locale=this.lang]]
       <b>
        {{bindings.0.schemeLabel.value}}{{bindings.0.entityType.value}}
       </b>
       [[i18n "and_iri" bundle="languages/resource_vocabularymanager" locale=this.lang]]
       <b>
        {{bindings.0.scheme.value}}
       </b>
<br/>
       [[i18n "already_exists" bundle="languages/resource_vocabularymanager" locale=this.lang]]
      </div>
      {{else}}
      <div>
       [[i18n "are_you" bundle="languages/resource_vocabularymanager" locale=this.lang]]
       <b>
        {{bindings.0.scheme.value}}
       </b>
       ?
      </div>
<semantic-form fields='[[
                                      fieldDefinitions
                                        prefLabel="http://www.w3.org/2004/02/skos/core#prefLabel"
                                        rdfsLabel="http://www.w3.org/2000/01/rdf-schema#label"
                                        classtype="http://www.w3.org/1999/02/22-rdf-syntax-ns#type"
                                        refersto="http://www.cidoc-crm.org/cidoc-crm/P67_refers_to"
                                        
                                    ]]' id="new-scheme-form" new-subject-template="{{bindings.0.scheme.value}}" persistence='{"type": "sparql", "targetGraphIri": "{{bindings.0.scheme.value}}"}' post-action="redirect">
<semantic-form-hidden-input default-value="{{bindings.0.entityType.value}}" for="refersto">
</semantic-form-hidden-input>
<semantic-form-hidden-input default-values='["http://www.cidoc-crm.org/cidoc-crm/E32_Authority_Document","http://www.cidoc-crm.org/cidoc-crm/E73_Information_Object"]' for="classtype">
</semantic-form-hidden-input>
<semantic-form-hidden-input default-value="{{bindings.0.schemeLabel.value}}" for="rdfsLabel">
</semantic-form-hidden-input>
<semantic-form-errors>
</semantic-form-errors>
<!-- save and reset button for form -->
<mp-event-trigger id="cancel-new-authority-trigger" targets='["new-hierarchy-dialog"]' type="OverlayDialog.Close">
<button class="btn btn-default" name="cancel" style="margin-right: 5px;">
         [[i18n "cancel" bundle="languages/resource_vocabularymanager" locale=this.lang]]
        </button>
</mp-event-trigger>
<button class="btn btn-success" name="submit">
        [[i18n "confirm" bundle="languages/resource_vocabularymanager" locale=this.lang]]
       </button>
</semantic-form>
      {{/if}}
     </div>
</template>
</semantic-query>
</semantic-search-result>
</semantic-search-result-holder>
</semantic-search>
[[/inline]]
    [[#*inline "customUploadNewStructureMessage"]]
<p>
 [[i18n "please_drag" bundle="languages/resource_vocabularymanager" locale=this.lang]]
</p>
<p>
 [[i18n "for_a" bundle="languages/resource_vocabularymanager" locale=this.lang]]
 <i>
  skos:ConceptScheme
 </i>
 [[i18n "or" bundle="languages/resource_vocabularymanager" locale=this.lang]]
 <i>
  crm:E32_Authority_Document
 </i>
 [[i18n "all_corresponding" bundle="languages/resource_vocabularymanager" locale=this.lang]]
</p>
[[/inline]]
    [[#*inline "exceptionsStructureList"]]
<semantic-query query="
                        SELECT ?scheme ?schemeGraph WHERE { 
                          {
                            GRAPH ?schemeGraph {
                              ?scheme a skos:ConceptScheme .
                            }
                          }
                          UNION {
                            GRAPH ?schemeGraph {
                              ?scheme a crm:E32_Authority_Document .
                            }
                          }
                          MINUS {
                            ?scheme crm:P2_has_type <http://www.researchspace.org/resource/system/System_Resource> 
                          }
                          FILTER(?schemeGraph != ?scheme) .
                        }
                        " template="{{>  template}}">
<template id="template">
<div class="warning-area">
<div class="warning-message">
<div>
     [[i18n "warning_there" bundle="languages/resource_vocabularymanager" locale=this.lang]]
    </div>
<div>
<i>
      skos:ConceptScheme, as well as crm:E32_Authority_Document
     </i>
     [[i18n "and_all" bundle="languages/resource_vocabularymanager" locale=this.lang]]
    </div>
</div>
<ul class="scheme-list">
    {{#each bindings}}
    <li>
<semantic-link iri="{{scheme.value}}">
</semantic-link>
     - IRI: {{scheme.value}} , in the graph: {{schemeGraph.value}}
    </li>
    {{/each}}
   </ul>
</div>
</template>
</semantic-query>
[[/inline]]
    [[#*inline "searchResults"]]
<semantic-search>
<div>
<semantic-search-query-keyword default-query='
                          SELECT DISTINCT ?scheme ?schemeLabel ?isManaged WHERE {
                                  {
                                      GRAPH ?scheme {
                                          ?scheme rdf:type skos:ConceptScheme;
                                                  skos:prefLabel ?schemeLabel.
                                          BIND(skos:ConceptScheme AS ?schemeType)
                                        	FILTER(lang(?schemeLabel)="en")
                                      }
                                  }
                                  UNION
                                  {
                                      GRAPH ?scheme {
                                          ?scheme rdf:type crm:E32_Authority_Document;
                                                  rdfs:label ?schemeLabel.

                                          BIND(crm:E32_Authority_Document AS ?schemeType)
                                        	FILTER(lang(?schemeLabel)="en")
                                      }
                                  }
                            MINUS {
                              ?scheme crm:P2_has_type <http://www.researchspace.org/resource/system/System_Resource> 
                            }
                            BIND(BOUND(?managedConfig) as ?isManaged) 
                          }
                      ' query='
                          PREFIX bds: <http://www.bigdata.com/rdf/search#> 
                          SELECT ?scheme ?schemeLabel ?isManaged WHERE {
                            {
                              GRAPH ?scheme {
                                ?scheme a skos:ConceptScheme ;
                                        skos:prefLabel ?schemeLabel .
                                ?schemeLabel bds:search ?__token__ .
                                FILTER(lang(?schemeLabel)="en")
                              }
                            }
                            UNION {
                              GRAPH ?scheme {
                                ?scheme rdf:type crm:E32_Authority_Document ;
                                        rdfs:label ?schemeLabel .
                                ?schemeLabel bds:search ?__token__ .
                                FILTER(lang(?schemeLabel)="en")
                              }
                            }
                            
                            OPTIONAL {
                              ?scheme crm:P67_refers_to ?managedConfig .
                            }
                            MINUS {
                              ?scheme crm:P2_has_type <http://www.researchspace.org/resource/system/System_Resource> 
                            }
                            BIND(BOUND(?managedConfig) as ?isManaged) .
                            
                          }
                      '>
</semantic-search-query-keyword>
</div>
<semantic-search-result-holder>
<semantic-search-result>
<semantic-table column-configuration='[
                              { "variableName": "scheme", "cellTemplate": "{{>  schemeRow}}" }
                          ]' id="scheme-table" no-result-template="{{>  noScheme}}" number-of-displayed-rows="15" options='{"showTableHeading": false, "showFilter": false}' query="SELECT DISTINCT ?scheme ?schemeLabel ?isManaged WHERE {} ORDER BY ASC(STR(LCASE(?schemeLabel)))">
<template id="noScheme">
<div style="padding: 12px 8px">
      [[i18n "no_authority" bundle="languages/resource_vocabularymanager" locale=this.lang]]
     </div>
</template>
<template id="schemeRow">
<div class="scheme-table-row">
<semantic-link class="schema-label" iri="{{scheme.value}}">
       {{schemeLabel.value}}
      </semantic-link>
<div class="btn-grey-container">
<semantic-link-container class="schema-label" uri="{{scheme.value}}">
<button class="btn-grey">
         [[i18n "show_terms" bundle="languages/resource_vocabularymanager" locale=this.lang]]
        </button>
</semantic-link-container>
<mp-overlay-dialog bs-size="large" title="Edit {{schemeLabel.value}}" type="modal">
<mp-overlay-dialog-trigger>
<button class="btn-grey">
          [[i18n "edit" bundle="languages/resource_vocabularymanager" locale=this.lang]]
         </button>
</mp-overlay-dialog-trigger>
<mp-overlay-dialog-content>
         {{#ifCond isManaged.value "===" "true"}}
         <semantic-form fields='[[
                                                      fieldDefinitions
                                                        rdfsLabel="http://www.w3.org/2000/01/rdf-schema#label"
                                                        prefLabel="http://www.w3.org/2004/02/skos/core#prefLabel"
                                                        classtype="http://www.w3.org/1999/02/22-rdf-syntax-ns#type"
                                                     ]]' id="vocab-form" persistence='{"type": "sparql", "targetGraphIri": "{{scheme.value}}"}' post-action="reload" subject="{{scheme.value}}">
<semantic-form-text-input for="rdfsLabel">
</semantic-form-text-input>
<semantic-form-text-input for="prefLabel">
</semantic-form-text-input>
<semantic-form-errors>
</semantic-form-errors>
<button class="btn btn-default" name="reset">
           [[i18n "reset" bundle="languages/resource_vocabularymanager" locale=this.lang]]
          </button>
<button class="btn btn-primary" name="submit">
           [[i18n "save" bundle="languages/resource_vocabularymanager" locale=this.lang]]
          </button>
</semantic-form>
         {{else}}
         <div>
          [[i18n "authority_list" bundle="languages/resource_vocabularymanager" locale=this.lang]]
          <b>
           {{schemeLabel.value}}
          </b>
          [[i18n "is_not" bundle="languages/resource_vocabularymanager" locale=this.lang]]
         </div>
<div>
          [[i18n "enable_authority" bundle="languages/resource_vocabularymanager" locale=this.lang]]
         </div>
<semantic-form fields='[{
                                                        "id": "refersto",
                                                        "label": "Entity Type",
                                                        "xsdDatatype": "xsd:anyURI",
                                                        "insertPattern": "INSERT { $subject <http://www.cidoc-crm.org/cidoc-crm/P67_refers_to>  $value } WHERE {}",
                                                        "deletePattern": "DELETE { $subject <http://www.cidoc-crm.org/cidoc-crm/P67_refers_to>  $value . } WHERE { $subject <http://www.cidoc-crm.org/cidoc-crm/P67_refers_to>  $value. }",
                                                        "valueSetPattern": "SELECT $value $label WHERE { 
                                                            ?value crm:P71i_is_listed_in <http://www.researchspace.org/resource/system/vocab/authority_manager_config_types>  .
                                                            ?value <http://www.researchspace.org/resource/system/authority_manager/item_label>  ?label .
                                                         }"
                                                        }
                                                      ]' id="manage-scheme-form" persistence='{"type": "sparql", "targetGraphIri": "{{scheme.value}}"}' post-action="redirect" subject="{{scheme.value}}">
<semantic-form-checklist-input class="class name" class-item-name="item class name" for="refersto" type="radio">
</semantic-form-checklist-input>
<semantic-form-errors>
</semantic-form-errors>
<button class="btn btn-primary" name="submit" style="margin-right: 5px;">
           [[i18n "confirm" bundle="languages/resource_vocabularymanager" locale=this.lang]]
          </button>
<button class="btn btn-default" name="cancel">
           [[i18n "cancel" bundle="languages/resource_vocabularymanager" locale=this.lang]]
          </button>
</semantic-form>
         {{/ifCond}}
        </mp-overlay-dialog-content>
</mp-overlay-dialog>
<button class="btn-grey">
<mp-graph-store-action action="GET" file-ending="trig" graphuri="{{scheme.value}}" title="[[i18n 'export' bundle='languages/resource_vocabularymanager' locale=this.lang]]">
         [[i18n "export" bundle="languages/resource_vocabularymanager" locale=this.lang]]
        </mp-graph-store-action>
</button>
<button class="btn-grey">
<mp-graph-store-action action="DELETE" graphuri="{{scheme.value}}" title="[[i18n 'delete' bundle='languages/resource_vocabularymanager' locale=this.lang]]">
         [[i18n "delete" bundle="languages/resource_vocabularymanager" locale=this.lang]]
        </mp-graph-store-action>
</button>
</div>
</div>
</template>
</semantic-table>
</semantic-search-result>
</semantic-search-result-holder>
</semantic-search>
[[/inline]]

[[/rsp:HierarchyManagerTemplate]]
